//© KDan 2023

#define	CLOCK_SPEED	CLOCK_8M
#define	USE_SOUND
#define	SOUND_FREQ	8000
#include "pocketlib.h"
#include "grafika.h"

extern u8 SoundB[];
extern u8 SoundBE[];
int xpos;
int i;
int lainmove;

void lainwin()
{
	xpos = 15;
	while(1)
	{
		FastLCDClear();
		for (i=7;i<25;i++) LCDbuffer[i] = gfxsmile[i-7];
		DrawString(xpos,1,"LAIN");
		DrawString(17-xpos,26,"WINS");
		FastLCDInvert(0,7);
		FastLCDInvert(25,7);
		VSync(1);
		if (xpos!=1) xpos--; else break;
	}
	WaitForButtonPress();
}
void lainlose()
{
	xpos = 15;
	while(1)
	{
		FastLCDClear();
		for (i=7;i<25;i++) LCDbuffer[i] = gfxsad[i-7];
		DrawString(xpos,1,"YOU");
		DrawString(21-xpos,26,"WIN");
		FastLCDInvert(0,7);
		FastLCDInvert(25,7);
		VSync(1);
		if (xpos!=1) xpos--; else break;
	}
	WaitForButtonPress();
}
void laindraw()
{
	xpos = 15;
	while(1)
	{
		FastLCDClear();
		for (i=7;i<25;i++) LCDbuffer[i] = gfxdraw[i-7];
		DrawString(xpos,1,"IT'S");
		DrawString(9-xpos,26,"A DRAW");
		FastLCDInvert(0,7);
		FastLCDInvert(25,7);
		VSync(1);
		if (xpos!=1) xpos--; else break;
	}
	WaitForButtonPress();
}

void animwait()
{
	VSync(1);
	VSync(0);
	VSync(1);
	VSync(0);
	VSync(1);
	VSync(0);
}
void resgfx(int left, int right)
{
	u32 tempLeft[32];
	u32 tempRight[32];
	
	switch(left){
		case 0:
			for (i=0;i<32;i++) tempLeft[i] = gfxkam[i];
			break;
		case 1:
			for (i=0;i<32;i++) tempLeft[i] = gfxpap[i];
			break;
		case 2:
			for (i=0;i<32;i++) tempLeft[i] = gfxnuz[i];
			break;
	}
	switch(right){
		case 0:
			for (i=0;i<32;i++) tempRight[i] = gfxkam[i];
			break;
		case 1:
			for (i=0;i<32;i++) tempRight[i] = gfxpap[i];
			break;
		case 2:
			for (i=0;i<32;i++) tempRight[i] = gfxnuz[i];
			break;
	}
	for (i=0;i<32;i++) {
		tempLeft[i] = (tempLeft[i]<<16)>>16;
		tempRight[i] = (tempRight[i]>>16)<<16;
	}
	for (i=0;i<32;i++) LCDbuffer[i] = tempLeft[i] | tempRight[i];
	animwait();
	animwait();
	animwait();
	animwait();
}

void anim()
{
	int loop;
	for(loop=0;loop<2;loop++)
	{
		FastLCDClear();
		for (i=0;i<32;i++) LCDbuffer[i] = gfxa2[i];
		animwait();
		FastLCDClear();
		for (i=0;i<32;i++) LCDbuffer[i] = gfxa1[i];
		animwait();
		FastLCDClear();
		for (i=0;i<32;i++) LCDbuffer[i] = gfxkam[i];
		animwait();
		animwait();
		animwait();
		FastLCDClear();
		for (i=0;i<32;i++) LCDbuffer[i] = gfxa1[i];
		animwait();
	}
	FastLCDClear();
	for (i=0;i<32;i++) LCDbuffer[i] = gfxa2[i];
	animwait();
	FastLCDClear();
	for (i=0;i<32;i++) LCDbuffer[i] = gfxa1[i];
	animwait();
	FastLCDClear();
}
void game(int move)
{
	anim();
	resgfx(move, lainmove);
	animwait();
	animwait();
	animwait();
	animwait();
	animwait();
	animwait();
	if (move == lainmove) laindraw();
	if ((move == 0 && lainmove == 1) || (move == 1 && lainmove == 2) || (move == 2 && lainmove == 0)) lainwin();
	if ((move == 1 && lainmove == 0) || (move == 2 && lainmove == 1) || (move == 0 && lainmove == 2)) lainlose();
}
void main(void)
{
	PocketInit();
	lainmove = 0;
	do
	{	 
		FastLCDClear();
		for (i=0;i<32;i++) LCDbuffer[i] = gfxmenu[i];
		VSync(1);
		if (PadOnPress & PAD_LEFT){
			PlaySound(SoundB, SoundBE-SoundB, 0);
			game(0);
		} 
		if (PadOnPress & PAD_UP){
			PlaySound(SoundB, SoundBE-SoundB, 0);
			game(1);
		}
		if (PadOnPress & PAD_RIGHT){
			PlaySound(SoundB, SoundBE-SoundB, 0);
			game(2);
		}
		if (PadOnRelease & PAD_DOWN) PocketExit();
		lainmove++;
		if(lainmove > 2) lainmove = 0;
	} while (1);
}